SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetNLUs] (
	@VCC Varchar(50) = NULL, 
	@SearchCriteria Varchar(50) = NULL, 
	@SearchExpression Varchar(50) = NULL,
	@Apps NVARCHAR(MAX),
	@IsSystemApp BIT = NULL,
	@ShowInMigrationProcess BIT = 0
	)
AS
BEGIN
	-- EN CASO EL FLAG LLEGUE NULL LO SETTEAMOS COMO 0
	
	DECLARE  @SQL              NVARCHAR(MAX)
	DECLARE  @FILTER           VARCHAR(MAX) = ''
	DECLARE  @EXCLUDING_FILTER VARCHAR(MAX) = ''
	SET @SQL = '
	SET NOCOUNT ON
	SELECT
		[VCC]							''vcc'',
		[Name]						    ''name'',
		[CognitiveEngine]				''cognitiveEngine'',
		[Culture]						''culture'',
		[Description]					''description'',
		[AppId]							''appId'',
		[SubscriptionKey]				''subscriptionKey'',
		[IsSystemApp]					''isSystemApp'',
		[NeedTrain]						''needTrain'',
		[IsTrained]						''isTrained'',
		[LastTrainedDate]				''lastTrainedDateTime'',
		[IsPublished]					''isPublished'',
		[LastPublishedDate]				''lastPublishedDateTime'',
		[CreatedDate]					''createdDate'',
		[CreatedByUserId]				''createdByUserId'',
		[LastModifiedDate]				''lastModifiedDate'',
		[LastModifiedByUserId]			''lastModifiedByUserId'',
		[Status]                        ''status'',
		[StatusCode]                    ''statusCode''
	FROM [NLU] (NOLOCK)
	WHERE ' 
	
	-- EN CASO BUSQUEMOS MODELOS DE TODOS LOS VCC
	IF (@VCC = 'ALL') 
		SET @SQL += '
			[VCC] IS NOT NULL '
	ELSE 
		SET @SQL += '
		[VCC] = ''' + @VCC + ''' '

	-- EN CASO BUSQUEMOS MODELOS DEL SISTEMA NO FILTRAMOS POR NOMBRES
	IF @IsSystemApp = 0 AND @Apps IS NOT NULL AND @Apps <> ''
		SET @FILTER += '
		AND [AppId] IN (''' + @Apps + ''') '
		
	IF(@ShowInMigrationProcess IS NOT NULL AND @ShowInMigrationProcess = 1)
	BEGIN 
	   IF(EXISTS(SELECT [Name] FROM [NLU] (NOLOCK) WHERE [VCC] = @VCC AND [IsSystemApp] = 0 AND [Status] <> 1))
        BEGIN 
           SET @FILTER = ''
	       SET @EXCLUDING_FILTER += ' AND [Status] <> 1 '
        END

	END
	ELSE 
	BEGIN 
	   SET @FILTER += ' AND  [Status] = 1 '
	END


	SET @FILTER += '
		AND [IsSystemApp] = ' + CASE WHEN @IsSystemApp = 1 THEN '1' ELSE '0' END + ' '

	IF @SearchCriteria IS NOT NULL AND @SearchCriteria  IS NOT NULL
		SET @FILTER += '
		AND ISNULL([Name], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''name'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
		AND ISNULL([Description], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''description'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
		AND ISNULL([LastModifiedByUserId], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''LastModifiedByUserId'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END'
    
    SET @SQL += @FILTER + @EXCLUDING_FILTER
	SET @SQL += '
	ORDER BY [LastModifiedDate] DESC, [Name] DESC'

	SET @SQL += ' SET NOCOUNT OFF'

	EXEC(@SQL)
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
