SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetNluIntentUtteranceToExport]
(
	@VCC	VARCHAR(50),
	@ListMode BIT = 0
)
AS
BEGIN
	SET NOCOUNT ON
	
	DECLARE @NLU TABLE(
	 [Name] VARCHAR(50),
	 AppId VARCHAR(50)
	)
	DECLARE @Intent TABLE (
	ID VARCHAR(50)
	)

	INSERT INTO @NLU SELECT [Name],[AppId] FROM [NLU]  (NOLOCK) WHERE [VCC] = @VCC AND [IsSystemApp] = 0
    INSERT INTO @Intent SELECT [IntentId] FROM [Intent] (NOLOCK) WHERE [VCC] = @VCC AND [AppId] IN (SELECT [AppId] FROM @NLU)

	IF(@ListMode = 0) -- CONTAR TOTAL DE REGISTROS
	   BEGIN

	       DECLARE @TotalNlu INT = 0
		   DECLARE @TotalIntent INT = 0
		   DECLARE @TotalUtterance INT = 0
		   DECLARE @TotalEntity INT = 0
		   DECLARE @NluNames VARCHAR(MAX) = NULL
		  
		  SELECT @TotalNlu = COUNT([Name]) FROM [NLU] (NOLOCK) WHERE [Name] IN (SELECT [Name] FROM @NLU)

		  SELECT @TotalIntent = COUNT([IntentId]) FROM [Intent] (NOLOCK) WHERE [IntentId] IN (SELECT ID FROM @Intent)

		  SELECT @TotalUtterance = COUNT([Id]) FROM [Utterance] (NOLOCK) WHERE [IntentId] IN (SELECT ID FROM @Intent)
		  
		  SELECT @TotalEntity = COUNT([ID]) FROM [dbo].[Entity] WHERE [VCC] = @VCC AND [AppId] IN (SELECT [AppId] FROM @NLU)

		  SELECT @TotalNlu AS TotalNlu,@TotalIntent AS TotalIntent,@TotalUtterance AS TotalUtterance, @TotalEntity AS TotalEntity
		  
		  SELECT @NluNames = STUFF(( SELECT ',' + [Name] FROM [NLU]  WHERE [VCC] = @VCC AND [IsSystemApp] = 0 FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, '')
          EXEC [GetNlusUsage] @VCC,@NluNames

	   END
	ELSE -- LISTAR REGISTROS
	   BEGIN
	   --NLUS
	       SELECT 
	       [Name] AS name,
	       [Culture] AS culture, 
	       [Description] AS description,
	       [AppId] AS appId,
	       [CognitiveEngine] AS cognitiveEngine,
	       0                 AS 'status'
	       FROM [NLU] (NOLOCK) WHERE [Name] IN (SELECT [Name] FROM @NLU)
		--INTENTS
		   SELECT
[Name]     'name',
[IntentId] 'intentId',
[AppId]     'appId',
0            'status'
FROM [Intent] (NOLOCK) WHERE [IntentId] IN (SELECT ID FROM @Intent)
		--UTTERANCES  
		  
		   SELECT 
 U.[Id] 'id',
 U.[AppId]       'appId',
 I.[Name]    'intent',
 U.[Text] 'name',
 (SELECT [EntityName] 'entityName',[Start] 'start',[End] 'end' 
 FROM [UtteranceEntity] (NOLOCK) WHERE [UtteranceId] IN(U.[Id]) FOR JSON AUTO) 'entityLabels',
 0                'status'
 
 FROM [Utterance] U (NOLOCK) 
 JOIN [Intent] I (NOLOCK)
 ON (U.VCC = I.VCC AND U.IntentId = I.IntentId)
 WHERE U.[IntentId] IN (SELECT ID FROM @Intent)
       --ENTITIES
 SELECT [AppId] 'appId',[ID] 'id',[Name] 'name',0 'status' FROM [dbo].[Entity] WHERE [VCC] = @VCC AND [AppId] IN (SELECT [AppId] FROM @NLU)
	   END

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
