SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetNlusUsage]
(
	@VCC	    VARCHAR(50),
	@NluNames		VARCHAR(MAX)= NULL
)
AS
BEGIN
	SET NOCOUNT ON

	DECLARE @NLUS TABLE (
	  ID VARCHAR(100)
	)
	DECLARE @FOUND_IN_STUDY BIT = 0

	INSERT INTO @NLUS SELECT CONCAT(N.[Name],'|',I.[Name]) FROM [NLU] N (NOLOCK) 
	JOIN [Intent] I (NOLOCK) ON (N.[AppId] = I.[AppId] AND N.[VCC] = I.[VCC]) 
	WHERE N.[VCC] = @VCC AND N.[Name] IN (SELECT [Value] FROM [dbo].[Split](@NluNames,','))

	   -- Validar para Study.
  

	IF(EXISTS( SELECT TTI.[ID] FROM  [TemplateThemeItem] TTI (NOLOCK) 
   JOIN [Study] S (NOLOCK) 
   ON ( TTI.TemplateId = S.TemplateId AND TTI.VCC = S.VCC)
   WHERE (S.[Status] IS NULL OR S.[Status] !=1 ) AND  S.VCC = @VCC AND TTI.[ID] IN (SELECT [ID] FROM @NLUS) ))		
   BEGIN 
        SET @FOUND_IN_STUDY = 1
   END
	
	SELECT @FOUND_IN_STUDY AS 'inUse'

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
